﻿function HandleOnChangeLookup() {
    //Jscript is going to look at the values you looked up for Type, and Site, and then when you look up a Resource, 
    // it will return a view of only Resources of that Type and Site.

    //Get the current Site
    var site = Xrm.Page.getAttribute("mcs_relatedsiteid").getValue();
    //site is a lookup, so it is getting the lookup data
    var type = Xrm.Page.getAttribute("mcs_type");
    var ResourceControl = Xrm.Page.ui.controls.get("mcs_relatedresourceid");
    var UserControl = Xrm.Page.ui.controls.get("mcs_relateduserid");


    if ((type != "undefined") && (type.getValue() != null) && (site != null)) {
        //for site in order to get the Guid of a lookup you use the [0], it is an array and the value is in position 0function HandleOnChangeLookup() {
        //Jscript is going to look at the values you looked up for Type, and Site, and then when you look up a Resource, 
        // it will return a view of only Resources of that Type and Site.

        //Get the current Site
        var site = Xrm.Page.getAttribute("mcs_relatedsiteid").getValue();
        //site is a lookup, so it is getting the lookup data
        var type = Xrm.Page.getAttribute("mcs_type");
        var ResourceControl = Xrm.Page.ui.controls.get("mcs_relatedresourceid");
        var UserControl = Xrm.Page.ui.controls.get("mcs_relateduserid");


        if ((type != "undefined") && (type.getValue() != null) && (site != null)) {
            //for site in order to get the Guid of a lookup you use the [0], it is an array and the value is in position 0
            var siteID = site[0].id;
            var viewID = siteID;
            var ViewDisplayName = "Filtered by Site and Type";
            var UserViewID = "{47127E79-C3A2-E211-9B92-00155D144F0F}";
            var ViewDisplayNameUser = "Filtered By Type";
            var viewIsDefault = true;

            var typeFieldValue = type.getValue();

            if (typeFieldValue == 917290000) {
                //Generate Fetch/Layout Xml for Resources and Users if the type is a Prov / Vista Clinic Pair
                var ResourcefetchXml = '<fetch version="1.0" output-format="xml-platform" mapping="logical" distinct="false"><entity name="mcs_resource"><attribute name="mcs_resourceid"/><attribute name="mcs_name"/><attribute name="createdon"/><order attribute="mcs_name" descending="false"/><filter type="and"><condition attribute="statecode" operator="eq" value="0"/><condition attribute="mcs_relatedsiteid" operator="eq" uiname="' + formatXML(site[0].name) + '" uitype="mcs_site" value="' + siteID + '"/></filter></entity></fetch>';
                //var ResourcefetchXml = '<fetch version="1.0" output-format="xml-platform" mapping="logical" distinct="false"><entity name="mcs_resource"><attribute name="mcs_resourceid"/><attribute name="mcs_name"/><attribute name="createdon"/><order attribute="mcs_name" descending="false"/><filter type="and"><condition attribute="statecode" operator="eq" value="0"/><condition attribute="mcs_relatedsiteid" operator="eq" uiname="' + site[0].name + '" uitype="mcs_site" value="' + siteID + '"/><condition attribute="mcs_type" operator="eq" value="251920000"/></filter></entity></fetch>';
                var ResourcelayoutXml = '<grid name="resultset" object="10006" jump="mcs_name" select="1" icon="0" preview="0"><row name="result" id="mcs_resourceid"><cell name="mcs_name" width="200" /><cell name="mcs_relatedsiteid" width="125" /><cell name="mcs_type" width="125" /></row></grid>';
                ResourceControl.addCustomView(viewID, "mcs_resource", "Filtered by Site (All Required)", ResourcefetchXml, ResourcelayoutXml, viewIsDefault);

                var ProUserfetchXml = '<fetch version="1.0" output-format="xml-platform" mapping="logical" distinct="false"><entity name="systemuser"><attribute name="fullname"/><attribute name="title"/><attribute name="address1_telephone1"/><attribute name="businessunitid"/><attribute name="cvt_type"/><attribute name="systemuserid"/><order attribute="fullname" descending="false"/><filter type="and"><condition attribute="isdisabled" operator="eq" value="0"/><condition attribute="accessmode" operator="ne" value="3"/><condition attribute="cvt_type" operator="eq" value="917290001"/></filter></entity></fetch>';
                var ProUserlayoutXml = '<grid name="resultset" object="8" jump="fullname" select="1" icon="0" preview="0"><row name="result" id="systemuserid"><cell name="fullname" width="200" /><cell name="cvt_type" width="125" /><cell name="businessunitid" width="150" /><cell name="title" width="100" /><cell name="address1_telephone1" width="100" /></row></grid>';
                UserControl.addCustomView(UserViewID, "systemuser", ViewDisplayNameUser, ProUserfetchXml, ProUserlayoutXml, viewIsDefault);
            }
            else
            {
                if (typeFieldValue == 100000000) {
                    //Generate Fetch/Layout Xml and add View if Type is Telepresenter
                    var TeleUserfetchXml = '<fetch version="1.0" output-format="xml-platform" mapping="logical" distinct="false"><entity name="systemuser"><attribute name="fullname"/><attribute name="title"/><attribute name="address1_telephone1"/><attribute name="businessunitid"/><attribute name="cvt_type"/><attribute name="systemuserid"/><order attribute="fullname" descending="false"/><filter type="and"><condition attribute="isdisabled" operator="eq" value="0"/><condition attribute="accessmode" operator="ne" value="3"/><condition attribute="cvt_type" operator="eq" value="917290000"/></filter></entity></fetch>';
                    var TeleUserlayoutXml = '<grid name="resultset" object="8" jump="fullname" select="1" icon="0" preview="0"><row name="result" id="systemuserid"><cell name="fullname" width="200" /><cell name="cvt_type" width="125" /><cell name="businessunitid" width="150" /><cell name="title" width="100" /><cell name="address1_telephone1" width="100" /></row></grid>';
                    UserControl.addCustomView(UserViewID, "systemuser", ViewDisplayNameUser, TeleUserfetchXml, TeleUserlayoutXml, viewIsDefault);
                }
                if (typeFieldValue == 99999999) {
                    //Generate Fetch/ Layout Xml and add View if Type is Provider
                    var ProUserfetchXml = '<fetch version="1.0" output-format="xml-platform" mapping="logical" distinct="false"><entity name="systemuser"><attribute name="fullname"/><attribute name="title"/><attribute name="address1_telephone1"/><attribute name="businessunitid"/><attribute name="cvt_type"/><attribute name="systemuserid"/><order attribute="fullname" descending="false"/><filter type="and"><condition attribute="isdisabled" operator="eq" value="0"/><condition attribute="accessmode" operator="ne" value="3"/><condition attribute="cvt_type" operator="eq" value="917290001"/></filter></entity></fetch>';
                    var ProUserlayoutXml = '<grid name="resultset" object="8" jump="fullname" select="1" icon="0" preview="0"><row name="result" id="systemuserid"><cell name="fullname" width="200" /><cell name="cvt_type" width="125" /><cell name="businessunitid" width="150" /><cell name="title" width="100" /><cell name="address1_telephone1" width="100" /></row></grid>';
                    UserControl.addCustomView(UserViewID, "systemuser", ViewDisplayNameUser, ProUserfetchXml, ProUserlayoutXml, viewIsDefault);
                }


                //Generate Fetch/Layout Xml and add View if Type is Room, Tech, or Vista Clinic
                var ResourcefetchXml = '<fetch version="1.0" output-format="xml-platform" mapping="logical" distinct="false"><entity name="mcs_resource"><attribute name="mcs_resourceid"/><attribute name="mcs_name"/><attribute name="createdon"/><order attribute="mcs_name" descending="false"/><filter type="and"><condition attribute="statecode" operator="eq" value="0"/><condition attribute="mcs_relatedsiteid" operator="eq" uiname="' + formatXML(site[0].name) + '" uitype="mcs_site" value="' + siteID + '"/><condition attribute="mcs_type" operator="eq" value="' + type.getValue() + '"/></filter></entity></fetch>';
                var ResourcelayoutXml = '<grid name="resultset" object="10006" jump="mcs_name" select="1" icon="1" preview="1"><row name="result" id="mcs_resourceid"><cell name="mcs_name" width="200" /><cell name="mcs_relatedsiteid" width="125" /><cell name="mcs_type" width="125" /></row></grid>';
                ResourceControl.addCustomView(viewID, "mcs_resource", ViewDisplayName, ResourcefetchXml, ResourcelayoutXml, viewIsDefault);
            }
       }
    }
}

function showDetails() {

    //get control for field
    var site = Xrm.Page.ui.controls.get("mcs_relatedsiteid");

    //get control for dependent field
    var type = Xrm.Page.ui.controls.get("mcs_type");
    var relatedResource = Xrm.Page.ui.controls.get("mcs_relatedresourceid");
    var relatedUser = Xrm.Page.ui.controls.get("mcs_relateduserid");

    //check if Type is null then get attribute value if not. 
    if (type != null) var typeFieldValue = type.getAttribute("mcs_type").getValue();

    if (site != null) var siteFieldValue = site.getAttribute("mcs_relatedsiteid").getValue();
    if (siteFieldValue != null) { site.setDisabled(true) }
    else { site.setDisabled(false) };

    //Check to see if Type is (0), and then see if there is a value for Type. Sets Visibility and Requirements.
    // Clears value of related Resource if no type is selected. 
    if (typeFieldValue != null) {
        type.setDisabled(true);

        if (typeFieldValue == 251920001 || typeFieldValue == 251920002 || typeFieldValue == 251920000) {

            relatedResource.setVisible(true);
            relatedResource.setFocus();
            Xrm.Page.getAttribute("mcs_relatedresourceid").setRequiredLevel("required");

            relatedUser.setVisible(false);
            Xrm.Page.getAttribute("mcs_relateduserid").setValue(null);
            Xrm.Page.getAttribute("mcs_relateduserid").setRequiredLevel("none");

        }

        //Check to see if Type is a Telepresenter or Provider User, and then sets visiblity and requirements levels. 
        if (typeFieldValue == 100000000 || typeFieldValue == 99999999) {
            relatedUser.setVisible(true);
            relatedUser.setFocus();
            Xrm.Page.getAttribute("mcs_relateduserid").setRequiredLevel("required");

            relatedResource.setVisible(false);
            Xrm.Page.getAttribute("mcs_relatedresourceid").setValue(null);
            Xrm.Page.getAttribute("mcs_relatedresourceid").setRequiredLevel("none");
        }

        if (typeFieldValue == 917290000) {
            relatedUser.setVisible(true);
            relatedResource.setVisible(true);
            Xrm.Page.getAttribute("mcs_relateduserid").setRequiredLevel("none");
            Xrm.Page.getAttribute("mcs_relatedresourceid").setRequiredLevel("none");

            if (relatedResource != null) var resourceFieldValue = relatedResource.getAttribute("mcs_relatedresourceid").getValue();
            if (relatedUser != null) var userFieldValue = relatedUser.getAttribute("mcs_relateduserid").getValue();

            if (resourceFieldValue != null) {

                Xrm.Page.getAttribute("mcs_relatedresourceid").setRequiredLevel("required");
                relatedUser.setVisible(false);
                Xrm.Page.getAttribute("mcs_relateduserid").setValue(null);
                Xrm.Page.getAttribute("mcs_relateduserid").setRequiredLevel("none");

            }
            else {
                relatedUser.setVisible(true);

            }
            if (userFieldValue != null) {
                Xrm.Page.getAttribute("mcs_relateduserid").setRequiredLevel("required");
                relatedResource.setVisible(false);
                Xrm.Page.getAttribute("mcs_relatedresourceid").setValue(null);
                Xrm.Page.getAttribute("mcs_relatedresourceid").setRequiredLevel("none");

            }
            else {
                relatedResource.setVisible(true);
            }
        }      
    }
    else
    {
        type.setDisabled(false);
    }
}

formatXML = function (str) {
    //replace & with &amp;
    if (str) {
        str = str.replace(/&/g, "&amp;");

        return str;
    }
};

CreateName = function () {
    /***********************************************************************
    /** 
    /** Description: CreateName
    /** 
    ***********************************************************************/

    var ResourceControl = Xrm.Page.ui.controls.get("mcs_relatedresourceid");
    var UserControl = Xrm.Page.ui.controls.get("mcs_relateduserid");

    var derivedResultField = "";

    if (ResourceControl.getVisible()) {
        var mcs_relatedresourceid = Xrm.Page.getAttribute("mcs_relatedresourceid").getValue();

        if (mcs_relatedresourceid != null) {
            derivedResultField = mcs_relatedresourceid[0].name;
        }
    }

    if (UserControl.getVisible() && derivedResultField == "") {
        var mcs_relateduserid = Xrm.Page.getAttribute("mcs_relateduserid").getValue();

        if (mcs_relateduserid != null) {
            derivedResultField = mcs_relateduserid[0].name;
        }
    }

    Xrm.Page.getAttribute("mcs_name").setSubmitMode("always");
    Xrm.Page.getAttribute("mcs_name").setValue(derivedResultField);
};
